
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 10 "parse_y.y"

/*
 *                            COPYRIGHT
 *
 *  PCB, interactive printed circuit board design
 *  Copyright (C) 1994,1995,1996 Thomas Nau
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Contact addresses for paper mail and Email:
 *  Thomas Nau, Schlehenweg 15, 88471 Baustetten, Germany
 *  Thomas.Nau@rz.uni-ulm.de
 *
 */

/* grammar to parse ASCII input of PCB description
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "global.h"
#include "create.h"
#include "data.h"
#include "error.h"
#include "file.h"
#include "flags.h"
#include "layerflags.h"
#include "mymem.h"
#include "misc.h"
#include "parse_l.h"
#include "polygon.h"
#include "remove.h"
#include "rtree.h"
#include "strflags.h"
#include "thermal.h"
#include "move.h"

#ifdef HAVE_LIBDMALLOC
# include <dmalloc.h> /* see http://dmalloc.com */
#endif

static	LayerType	*Layer;
static	PolygonType	*Polygon;
static	SymbolType	*Symbol;
static	int		pin_num;
static	LibraryMenuType	*Menu;
static	bool			LayerFlag[MAX_ALL_LAYER];

enum FileType {NOFILE=0, PCBFILE, DATAFILE, FONTFILE} file_type;

extern	char		*yytext;		/* defined by LEX */
extern	PCBType		*yyPCB;
extern	DataType	*yyData;
extern	ElementType	*yyElement;
extern	FontType	*yyFont;
extern	int		yylineno;		/* linenumber */
extern	char		*yyfilename;	/* in this file */

static AttributeListType *attr_list; 

int yyerror(const char *s);
int yylex();
static int check_file_version (int);

static void do_measure (PLMeasure *m, Coord i, double d, int u);
#define M(r,f,d) do_measure (&(r), f, d, 1)

/* Macros for interpreting what "measure" means - integer value only,
   old units (mil), or new units (cmil).  */
#define IV(m) integer_value (m)
#define OU(m) old_units (m)
#define NU(m) new_units (m)

static int integer_value (PLMeasure m);
static Coord old_units (PLMeasure m);
static Coord new_units (PLMeasure m);

/*
#define YYDEBUG 1
#define YYERROR_VERBOSE 1
int yydebug=1;
*/

#include "parse_y.h"



/* Line 189 of yacc.c  */
#line 175 "parse_y.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     FLOATING = 258,
     INTEGER = 259,
     CHAR_CONST = 260,
     STRING = 261,
     T_FILEVERSION = 262,
     T_PCB = 263,
     T_LAYER = 264,
     T_VIA = 265,
     T_RAT = 266,
     T_LINE = 267,
     T_ARC = 268,
     T_RECTANGLE = 269,
     T_TEXT = 270,
     T_ELEMENTLINE = 271,
     T_ELEMENT = 272,
     T_PIN = 273,
     T_PAD = 274,
     T_GRID = 275,
     T_FLAGS = 276,
     T_SYMBOL = 277,
     T_SYMBOLLINE = 278,
     T_CURSOR = 279,
     T_ELEMENTARC = 280,
     T_MARK = 281,
     T_GROUPS = 282,
     T_STYLES = 283,
     T_POLYGON = 284,
     T_POLYGON_HOLE = 285,
     T_NETLIST = 286,
     T_NET = 287,
     T_CONN = 288,
     T_AREA = 289,
     T_THERMAL = 290,
     T_DRC = 291,
     T_ATTRIBUTE = 292,
     T_UMIL = 293,
     T_CMIL = 294,
     T_MIL = 295,
     T_IN = 296,
     T_NM = 297,
     T_UM = 298,
     T_MM = 299,
     T_M = 300,
     T_KM = 301,
     T_PX = 302
   };
#endif
/* Tokens.  */
#define FLOATING 258
#define INTEGER 259
#define CHAR_CONST 260
#define STRING 261
#define T_FILEVERSION 262
#define T_PCB 263
#define T_LAYER 264
#define T_VIA 265
#define T_RAT 266
#define T_LINE 267
#define T_ARC 268
#define T_RECTANGLE 269
#define T_TEXT 270
#define T_ELEMENTLINE 271
#define T_ELEMENT 272
#define T_PIN 273
#define T_PAD 274
#define T_GRID 275
#define T_FLAGS 276
#define T_SYMBOL 277
#define T_SYMBOLLINE 278
#define T_CURSOR 279
#define T_ELEMENTARC 280
#define T_MARK 281
#define T_GROUPS 282
#define T_STYLES 283
#define T_POLYGON 284
#define T_POLYGON_HOLE 285
#define T_NETLIST 286
#define T_NET 287
#define T_CONN 288
#define T_AREA 289
#define T_THERMAL 290
#define T_DRC 291
#define T_ATTRIBUTE 292
#define T_UMIL 293
#define T_CMIL 294
#define T_MIL 295
#define T_IN 296
#define T_NM 297
#define T_UM 298
#define T_MM 299
#define T_M 300
#define T_KM 301
#define T_PX 302




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 114 "parse_y.y"

	int		integer;
	double		number;
	char		*string;
	FlagType	flagtype;
	PLMeasure	measure;



/* Line 214 of yacc.c  */
#line 315 "parse_y.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 327 "parse_y.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  9
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   795

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  52
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  108
/* YYNRULES -- Number of rules.  */
#define YYNRULES  205
/* YYNRULES -- Number of states.  */
#define YYNSTATES  621

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   302

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      50,    51,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    48,     2,    49,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     7,     9,    11,    12,    27,    28,
      31,    32,    35,    36,    37,    40,    41,    46,    51,    58,
      65,    67,    69,    71,    78,    86,    94,   101,   108,   109,
     110,   115,   116,   121,   122,   124,   126,   128,   135,   143,
     153,   158,   163,   164,   169,   170,   175,   180,   181,   183,
     184,   186,   189,   191,   192,   195,   197,   199,   200,   203,
     205,   207,   209,   211,   213,   215,   229,   241,   253,   264,
     274,   283,   294,   305,   306,   317,   319,   320,   322,   325,
     327,   329,   331,   333,   335,   337,   346,   348,   350,   352,
     353,   356,   358,   369,   380,   390,   403,   416,   428,   437,
     447,   457,   458,   468,   469,   472,   473,   479,   480,   483,
     488,   493,   495,   497,   499,   501,   503,   504,   517,   518,
     534,   535,   552,   553,   572,   573,   592,   594,   597,   599,
     601,   603,   605,   607,   616,   625,   636,   647,   653,   659,
     660,   663,   665,   668,   670,   672,   674,   676,   685,   694,
     705,   716,   717,   720,   733,   746,   757,   767,   776,   790,
     804,   816,   827,   829,   831,   833,   836,   840,   847,   854,
     856,   858,   859,   862,   865,   874,   883,   885,   886,   893,
     895,   896,   898,   901,   902,   912,   914,   915,   917,   920,
     925,   931,   933,   934,   936,   938,   940,   943,   946,   949,
     952,   955,   958,   961,   964,   967
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
      53,     0,    -1,    54,    -1,    56,    -1,    60,    -1,     1,
      -1,    -1,    55,    62,    63,    64,    68,    69,    70,    71,
      75,    76,    77,    58,    78,   147,    -1,    -1,    57,    78,
      -1,    -1,    59,    60,    -1,    -1,    -1,    61,   140,    -1,
      -1,     7,    48,     4,    49,    -1,     8,    50,     6,    51,
      -1,     8,    50,     6,   159,   159,    51,    -1,     8,    48,
       6,   159,   159,    49,    -1,    65,    -1,    66,    -1,    67,
      -1,    20,    50,   159,   159,   159,    51,    -1,    20,    50,
     159,   159,   159,     4,    51,    -1,    20,    48,   159,   159,
     159,     4,    49,    -1,    24,    50,   159,   159,   158,    51,
      -1,    24,    48,   159,   159,   158,    49,    -1,    -1,    -1,
      34,    48,   158,    49,    -1,    -1,    35,    48,   158,    49,
      -1,    -1,    72,    -1,    73,    -1,    74,    -1,    36,    48,
     159,   159,   159,    49,    -1,    36,    48,   159,   159,   159,
     159,    49,    -1,    36,    48,   159,   159,   159,   159,   159,
     159,    49,    -1,    21,    50,     4,    51,    -1,    21,    50,
       6,    51,    -1,    -1,    27,    50,     6,    51,    -1,    -1,
      28,    50,     6,    51,    -1,    28,    48,     6,    49,    -1,
      -1,    79,    -1,    -1,    80,    -1,    79,    80,    -1,    83,
      -1,    -1,    81,   156,    -1,    90,    -1,    91,    -1,    -1,
      82,   113,    -1,    84,    -1,    85,    -1,    86,    -1,    87,
      -1,    88,    -1,    89,    -1,    10,    48,   159,   159,   159,
     159,   159,   159,     4,     4,     6,   139,    49,    -1,    10,
      48,   159,   159,   159,   159,   159,   159,     6,   139,    49,
      -1,    10,    50,   159,   159,   159,   159,   159,   159,     6,
       4,    51,    -1,    10,    50,   159,   159,   159,   159,   159,
       6,     4,    51,    -1,    10,    50,   159,   159,   159,   159,
       6,     4,    51,    -1,    10,    50,   159,   159,   159,     6,
       4,    51,    -1,    11,    48,   159,   159,     4,   159,   159,
       4,   139,    49,    -1,    11,    50,   159,   159,     4,   159,
     159,     4,     4,    51,    -1,    -1,     9,    50,     4,     6,
     157,    51,    50,    92,    93,    51,    -1,    94,    -1,    -1,
      95,    -1,    94,    95,    -1,    97,    -1,    98,    -1,    99,
      -1,   100,    -1,   101,    -1,   102,    -1,    14,    50,   159,
     159,   159,   159,     4,    51,    -1,   105,    -1,   104,    -1,
     103,    -1,    -1,    96,   156,    -1,   106,    -1,    12,    48,
     159,   159,   159,   159,   159,   159,   139,    49,    -1,    12,
      50,   159,   159,   159,   159,   159,   159,     4,    51,    -1,
      12,    50,   159,   159,   159,   159,   159,   159,    51,    -1,
      13,    48,   159,   159,   159,   159,   159,   159,   158,   158,
     139,    49,    -1,    13,    50,   159,   159,   159,   159,   159,
     159,   158,   158,     4,    51,    -1,    13,    50,   159,   159,
     159,   159,   159,   159,   158,     4,    51,    -1,    15,    50,
     159,   159,   158,     6,     4,    51,    -1,    15,    50,   159,
     159,   158,   158,     6,     4,    51,    -1,    15,    48,   159,
     159,   158,   158,     6,   139,    49,    -1,    -1,    29,    50,
     139,    51,    50,   107,   111,   108,    51,    -1,    -1,   108,
     109,    -1,    -1,    30,    50,   110,   111,    51,    -1,    -1,
     112,   111,    -1,    50,   159,   159,    51,    -1,    48,   159,
     159,    49,    -1,   114,    -1,   116,    -1,   118,    -1,   120,
      -1,   122,    -1,    -1,    17,    50,     6,     6,   159,   159,
       4,    51,    50,   115,   124,    51,    -1,    -1,    17,    50,
       4,     6,     6,   159,   159,   159,   159,     4,    51,    50,
     117,   124,    51,    -1,    -1,    17,    50,     4,     6,     6,
       6,   159,   159,   159,   159,     4,    51,    50,   119,   124,
      51,    -1,    -1,    17,    50,     4,     6,     6,     6,   159,
     159,   159,   159,   158,   158,     4,    51,    50,   121,   127,
      51,    -1,    -1,    17,    48,   139,     6,     6,     6,   159,
     159,   159,   159,   158,   158,   139,    49,    50,   123,   127,
      51,    -1,   125,    -1,   124,   125,    -1,   132,    -1,   133,
      -1,   134,    -1,   137,    -1,   138,    -1,    16,    48,   159,
     159,   159,   159,   159,    49,    -1,    16,    50,   159,   159,
     159,   159,   159,    51,    -1,    25,    48,   159,   159,   159,
     159,   158,   158,   159,    49,    -1,    25,    50,   159,   159,
     159,   159,   158,   158,   159,    51,    -1,    26,    48,   159,
     159,    49,    -1,    26,    50,   159,   159,    51,    -1,    -1,
     126,   156,    -1,   128,    -1,   127,   128,    -1,   131,    -1,
     130,    -1,   136,    -1,   135,    -1,    16,    48,   159,   159,
     159,   159,   159,    49,    -1,    16,    50,   159,   159,   159,
     159,   159,    51,    -1,    25,    48,   159,   159,   159,   159,
     158,   158,   159,    49,    -1,    25,    50,   159,   159,   159,
     159,   158,   158,   159,    51,    -1,    -1,   129,   156,    -1,
      18,    48,   159,   159,   159,   159,   159,   159,     6,     6,
     139,    49,    -1,    18,    50,   159,   159,   159,   159,   159,
     159,     6,     6,     4,    51,    -1,    18,    50,   159,   159,
     159,   159,     6,     6,     4,    51,    -1,    18,    50,   159,
     159,   159,   159,     6,     4,    51,    -1,    18,    50,   159,
     159,   159,     6,     4,    51,    -1,    19,    48,   159,   159,
     159,   159,   159,   159,   159,     6,     6,   139,    49,    -1,
      19,    50,   159,   159,   159,   159,   159,   159,   159,     6,
       6,     4,    51,    -1,    19,    50,   159,   159,   159,   159,
     159,     6,     6,     4,    51,    -1,    19,    50,   159,   159,
     159,   159,   159,     6,     4,    51,    -1,     4,    -1,     6,
      -1,   141,    -1,   140,   141,    -1,   142,   144,    51,    -1,
      22,    48,   143,   159,    49,    50,    -1,    22,    50,   143,
     159,    51,    50,    -1,     4,    -1,     5,    -1,    -1,   144,
     145,    -1,   144,   146,    -1,    23,    50,   159,   159,   159,
     159,   159,    51,    -1,    23,    48,   159,   159,   159,   159,
     159,    49,    -1,   148,    -1,    -1,    31,    50,    51,    50,
     149,    51,    -1,   150,    -1,    -1,   151,    -1,   150,   151,
      -1,    -1,    32,    50,     6,     6,    51,    50,   152,   153,
      51,    -1,   154,    -1,    -1,   155,    -1,   154,   155,    -1,
      33,    50,     6,    51,    -1,    37,    50,     6,     6,    51,
      -1,     6,    -1,    -1,     3,    -1,     4,    -1,   158,    -1,
     158,    38,    -1,   158,    39,    -1,   158,    40,    -1,   158,
      41,    -1,   158,    42,    -1,   158,    47,    -1,   158,    43,
      -1,   158,    44,    -1,   158,    45,    -1,   158,    46,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   140,   140,   141,   142,   143,   179,   179,   234,   234,
     262,   262,   265,   270,   270,   310,   312,   351,   357,   363,
     401,   402,   403,   406,   414,   427,   466,   471,   476,   492,
     494,   519,   521,   552,   554,   555,   556,   560,   570,   581,
     608,   612,   617,   645,   654,   710,   719,   728,   732,   733,
     737,   738,   742,   743,   743,   744,   745,   746,   746,   784,
     785,   786,   787,   788,   789,   851,   861,   871,   882,   892,
     902,   942,   947,   991,   990,  1020,  1021,  1025,  1026,  1030,
    1031,  1032,  1033,  1034,  1035,  1037,  1042,  1043,  1044,  1045,
    1045,  1046,  1085,  1094,  1103,  1160,  1169,  1178,  1224,  1234,
    1252,  1316,  1315,  1355,  1357,  1362,  1361,  1368,  1370,  1375,
    1379,  1450,  1451,  1452,  1453,  1454,  1462,  1461,  1480,  1479,
    1498,  1497,  1518,  1516,  1540,  1538,  1640,  1641,  1645,  1646,
    1647,  1648,  1649,  1651,  1656,  1661,  1666,  1671,  1676,  1681,
    1681,  1685,  1686,  1690,  1691,  1692,  1693,  1695,  1701,  1708,
    1713,  1718,  1718,  1768,  1780,  1792,  1803,  1819,  1877,  1891,
    1904,  1915,  1926,  1927,  1931,  1932,  1965,  1967,  1983,  2002,
    2003,  2006,  2008,  2009,  2039,  2046,  2062,  2063,  2067,  2072,
    2073,  2077,  2078,  2101,  2100,  2110,  2111,  2115,  2116,  2135,
    2194,  2202,  2203,  2207,  2208,  2213,  2214,  2215,  2216,  2217,
    2218,  2219,  2220,  2221,  2222,  2223
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "FLOATING", "INTEGER", "CHAR_CONST",
  "STRING", "T_FILEVERSION", "T_PCB", "T_LAYER", "T_VIA", "T_RAT",
  "T_LINE", "T_ARC", "T_RECTANGLE", "T_TEXT", "T_ELEMENTLINE", "T_ELEMENT",
  "T_PIN", "T_PAD", "T_GRID", "T_FLAGS", "T_SYMBOL", "T_SYMBOLLINE",
  "T_CURSOR", "T_ELEMENTARC", "T_MARK", "T_GROUPS", "T_STYLES",
  "T_POLYGON", "T_POLYGON_HOLE", "T_NETLIST", "T_NET", "T_CONN", "T_AREA",
  "T_THERMAL", "T_DRC", "T_ATTRIBUTE", "T_UMIL", "T_CMIL", "T_MIL", "T_IN",
  "T_NM", "T_UM", "T_MM", "T_M", "T_KM", "T_PX", "'['", "']'", "'('",
  "')'", "$accept", "parse", "parsepcb", "$@1", "parsedata", "$@2",
  "pcbfont", "$@3", "parsefont", "$@4", "pcbfileversion", "pcbname",
  "pcbgrid", "pcbgridold", "pcbgridnew", "pcbhigrid", "pcbcursor",
  "polyarea", "pcbthermal", "pcbdrc", "pcbdrc1", "pcbdrc2", "pcbdrc3",
  "pcbflags", "pcbgroups", "pcbstyles", "pcbdata", "pcbdefinitions",
  "pcbdefinition", "$@5", "$@6", "via", "via_ehi_format", "via_hi_format",
  "via_2.0_format", "via_1.7_format", "via_newformat", "via_oldformat",
  "rats", "layer", "$@7", "layerdata", "layerdefinitions",
  "layerdefinition", "$@8", "line_hi_format", "line_1.7_format",
  "line_oldformat", "arc_hi_format", "arc_1.7_format", "arc_oldformat",
  "text_oldformat", "text_newformat", "text_hi_format", "polygon_format",
  "$@9", "polygonholes", "polygonhole", "$@10", "polygonpoints",
  "polygonpoint", "element", "element_oldformat", "$@11",
  "element_1.3.4_format", "$@12", "element_newformat", "$@13",
  "element_1.7_format", "$@14", "element_hi_format", "$@15",
  "elementdefinitions", "elementdefinition", "$@16", "relementdefs",
  "relementdef", "$@17", "pin_hi_format", "pin_1.7_format",
  "pin_1.6.3_format", "pin_newformat", "pin_oldformat", "pad_hi_format",
  "pad_1.7_format", "pad_newformat", "pad", "flags", "symbols", "symbol",
  "symbolhead", "symbolid", "symboldata", "symboldefinition",
  "hiressymbol", "pcbnetlist", "pcbnetdef", "nets", "netdefs", "net",
  "$@18", "connections", "conndefs", "conn", "attribute", "opt_string",
  "number", "measure", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,    91,    93,
      40,    41
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    52,    53,    53,    53,    53,    55,    54,    57,    56,
      59,    58,    58,    61,    60,    62,    62,    63,    63,    63,
      64,    64,    64,    65,    66,    67,    68,    68,    68,    69,
      69,    70,    70,    71,    71,    71,    71,    72,    73,    74,
      75,    75,    75,    76,    76,    77,    77,    77,    78,    78,
      79,    79,    80,    81,    80,    80,    80,    82,    80,    83,
      83,    83,    83,    83,    83,    84,    85,    86,    87,    88,
      89,    90,    90,    92,    91,    93,    93,    94,    94,    95,
      95,    95,    95,    95,    95,    95,    95,    95,    95,    96,
      95,    95,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   107,   106,   108,   108,   110,   109,   111,   111,   112,
     112,   113,   113,   113,   113,   113,   115,   114,   117,   116,
     119,   118,   121,   120,   123,   122,   124,   124,   125,   125,
     125,   125,   125,   125,   125,   125,   125,   125,   125,   126,
     125,   127,   127,   128,   128,   128,   128,   128,   128,   128,
     128,   129,   128,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   139,   140,   140,   141,   142,   142,   143,
     143,   144,   144,   144,   145,   146,   147,   147,   148,   149,
     149,   150,   150,   152,   151,   153,   153,   154,   154,   155,
     156,   157,   157,   158,   158,   159,   159,   159,   159,   159,
     159,   159,   159,   159,   159,   159
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     1,     1,     0,    14,     0,     2,
       0,     2,     0,     0,     2,     0,     4,     4,     6,     6,
       1,     1,     1,     6,     7,     7,     6,     6,     0,     0,
       4,     0,     4,     0,     1,     1,     1,     6,     7,     9,
       4,     4,     0,     4,     0,     4,     4,     0,     1,     0,
       1,     2,     1,     0,     2,     1,     1,     0,     2,     1,
       1,     1,     1,     1,     1,    13,    11,    11,    10,     9,
       8,    10,    10,     0,    10,     1,     0,     1,     2,     1,
       1,     1,     1,     1,     1,     8,     1,     1,     1,     0,
       2,     1,    10,    10,     9,    12,    12,    11,     8,     9,
       9,     0,     9,     0,     2,     0,     5,     0,     2,     4,
       4,     1,     1,     1,     1,     1,     0,    12,     0,    15,
       0,    16,     0,    18,     0,    18,     1,     2,     1,     1,
       1,     1,     1,     8,     8,    10,    10,     5,     5,     0,
       2,     1,     2,     1,     1,     1,     1,     8,     8,    10,
      10,     0,     2,    12,    12,    10,     9,     8,    13,    13,
      11,    10,     1,     1,     1,     2,     3,     6,     6,     1,
       1,     0,     2,     2,     8,     8,     1,     0,     6,     1,
       0,     1,     2,     0,     9,     1,     0,     1,     2,     4,
       5,     1,     0,     1,     1,     1,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     5,     0,     2,    15,     3,    49,     4,     0,     1,
       0,     0,     0,     0,     0,     9,    48,    50,     0,     0,
      52,    59,    60,    61,    62,    63,    64,    55,    56,     0,
      14,   164,   171,     0,     0,     0,     0,     0,     0,     0,
       0,    51,     0,    54,     0,    58,   111,   112,   113,   114,
     115,     0,     0,   165,     0,     0,     0,     0,     0,    28,
      20,    21,    22,     0,   193,   194,   195,     0,     0,     0,
       0,     0,     0,     0,   169,   170,     0,     0,     0,   166,
     172,   173,    16,     0,     0,     0,     0,     0,    29,   192,
     196,   197,   198,   199,   200,   202,   203,   204,   205,   201,
       0,     0,     0,     0,     0,   162,   163,     0,     0,     0,
       0,     0,     0,     0,     0,    17,     0,     0,     0,     0,
       0,     0,    31,   191,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    33,     0,     0,     0,     0,
       0,     0,   190,     0,     0,     0,   167,   168,     0,     0,
      19,    18,     0,     0,     0,     0,     0,     0,     0,    42,
      34,    35,    36,    73,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    23,     0,
       0,    30,     0,     0,     0,    44,    76,     0,    70,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      25,    24,    27,    26,    32,     0,     0,     0,    47,     0,
       0,     0,     0,     0,     0,    75,    77,     0,    79,    80,
      81,    82,    83,    84,    88,    87,    86,    91,     0,     0,
      69,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    12,     0,     0,     0,
       0,     0,     0,     0,     0,    74,    78,    90,     0,     0,
      68,     0,    71,    72,     0,     0,     0,   116,   175,   174,
       0,    40,    41,     0,     0,     0,    49,    13,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    66,    67,     0,
       0,     0,   139,    37,     0,    43,     0,     0,   177,    11,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     194,     0,     0,     0,     0,     0,     0,     0,   139,   126,
       0,   128,   129,   130,   131,   132,    38,     0,    46,    45,
       0,     7,   176,     0,     0,     0,     0,     0,     0,     0,
     101,    65,     0,     0,     0,   118,     0,     0,     0,     0,
       0,     0,     0,     0,   117,   127,   140,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   107,     0,   120,
       0,   139,     0,     0,     0,     0,     0,     0,     0,     0,
      39,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   103,   107,     0,   139,     0,   139,     0,     0,
       0,     0,     0,     0,     0,     0,   180,     0,     0,     0,
       0,    85,     0,    98,     0,     0,     0,     0,   108,   124,
     139,   122,   119,     0,     0,     0,     0,     0,     0,   137,
     138,     0,     0,   179,   181,     0,     0,    94,     0,     0,
     100,    99,     0,     0,     0,   102,   104,   151,   121,   151,
       0,     0,     0,     0,     0,     0,     0,     0,   178,   182,
      92,    93,     0,   194,     0,   110,   109,   105,     0,     0,
       0,     0,   151,   141,     0,   144,   143,   146,   145,   151,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    97,
       0,   107,     0,     0,     0,     0,     0,     0,     0,     0,
     125,   142,   152,   123,   133,   134,   157,     0,     0,     0,
       0,     0,     0,    95,    96,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   156,     0,     0,     0,     0,     0,
       0,   106,     0,     0,     0,     0,     0,     0,     0,     0,
     155,   161,     0,   135,   136,   183,     0,     0,     0,     0,
       0,     0,     0,     0,   160,   186,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   185,   187,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   184,   188,   147,
     148,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   189,     0,     0,     0,     0,   149,
     150,     0,     0,     0,     0,   153,   154,     0,     0,   158,
     159
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,     4,     5,     6,   286,   287,     7,     8,
      11,    35,    59,    60,    61,    62,    88,   122,   145,   169,
     170,   171,   172,   195,   218,   256,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
     196,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   377,   427,   456,   501,   402,
     403,    45,    46,   302,    47,   381,    48,   405,    49,   459,
      50,   457,   328,   329,   330,   482,   483,   484,   485,   486,
     331,   332,   333,   487,   488,   334,   335,   107,    30,    31,
      32,    76,    54,    80,    81,   341,   342,   442,   443,   444,
     565,   575,   576,   577,    43,   124,    66,    67
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -468
static const yytype_int16 yypact[] =
{
     152,  -468,    37,  -468,    33,  -468,    55,  -468,    -5,  -468,
      -4,    46,    19,    90,   108,  -468,    55,  -468,    40,    74,
    -468,  -468,  -468,  -468,  -468,  -468,  -468,  -468,  -468,   132,
      -5,  -468,  -468,   110,   138,    95,   114,    20,    20,    20,
      20,  -468,    60,  -468,   168,  -468,  -468,  -468,  -468,  -468,
    -468,    23,    23,  -468,    -2,    70,   117,   120,   184,   105,
    -468,  -468,  -468,   127,  -468,  -468,   154,    20,    20,    20,
      20,   135,    49,   198,  -468,  -468,    20,    20,   190,  -468,
    -468,  -468,  -468,    20,     5,    20,    20,   191,   111,   148,
    -468,  -468,  -468,  -468,  -468,  -468,  -468,  -468,  -468,  -468,
      20,    20,   171,   183,   158,  -468,  -468,   166,   204,   222,
     186,   197,    20,    20,    20,  -468,    20,    20,    20,    20,
      20,   216,   262,  -468,   226,    20,    67,    20,    20,   229,
     295,   296,    20,   253,   254,    20,    20,   261,   263,    20,
      20,    20,    20,    20,   265,   279,   266,    20,   313,    80,
      20,    20,  -468,   320,   131,    20,  -468,  -468,    20,    20,
    -468,  -468,   323,    -1,    20,    20,   280,    20,   282,   307,
    -468,  -468,  -468,  -468,    20,   284,   332,   211,   333,   334,
      20,    20,    20,   335,    20,    20,   291,   292,  -468,   293,
     301,  -468,   304,    20,   308,   314,   136,   239,  -468,   309,
     355,   358,    49,   357,    20,    20,    20,   315,    20,    20,
    -468,  -468,  -468,  -468,  -468,    20,   240,   317,   337,   199,
     209,   318,   210,   319,   325,   136,  -468,    40,  -468,  -468,
    -468,  -468,  -468,  -468,  -468,  -468,  -468,  -468,   373,    49,
    -468,   327,   375,   331,   330,    20,    20,    20,   336,   340,
     339,    20,   341,   342,   379,   217,   369,    20,    20,    20,
      20,    20,    20,    20,    49,  -468,  -468,  -468,   388,   352,
    -468,   351,  -468,  -468,    20,    20,   399,  -468,  -468,  -468,
       8,  -468,  -468,   353,   400,   401,    55,  -468,    20,    20,
      20,    20,    20,    20,    20,   354,    49,  -468,  -468,    20,
      92,   359,   165,  -468,    10,  -468,   360,   362,   377,  -468,
      20,    20,    20,    20,    20,    20,    20,   364,   366,    20,
     365,    20,   367,   220,   368,   370,   221,   233,     0,  -468,
      40,  -468,  -468,  -468,  -468,  -468,  -468,    20,  -468,  -468,
     374,  -468,  -468,    20,    20,    20,    20,    20,    20,   223,
    -468,  -468,    49,   380,   415,  -468,    20,    20,    20,    20,
      20,    20,    20,    20,  -468,  -468,  -468,   376,   381,    20,
      20,    20,    20,   423,   425,   429,   428,   237,   386,  -468,
     385,   165,    20,    20,    20,    20,    20,    20,    20,    20,
    -468,   387,    20,    20,    20,    20,   389,    49,   390,   434,
      20,    20,  -468,   237,   392,   165,   393,    17,    20,    20,
      20,    20,    20,    20,   395,   394,   407,    49,     1,    20,
      20,  -468,   398,  -468,   397,    20,    20,   -10,  -468,  -468,
     106,  -468,  -468,    20,    20,   227,    20,    20,    20,  -468,
    -468,   402,   403,   407,  -468,   404,   405,  -468,    20,    96,
    -468,  -468,   406,   409,   411,  -468,  -468,   187,  -468,   187,
      20,    20,   445,   444,    20,    20,    20,   451,  -468,  -468,
    -468,  -468,    49,   412,   447,  -468,  -468,  -468,   238,   241,
     242,   245,    42,  -468,    40,  -468,  -468,  -468,  -468,   160,
     413,   421,   422,   290,   468,    20,    20,   469,   427,  -468,
     426,   237,    20,    20,    20,    20,    20,    20,    20,    20,
    -468,  -468,  -468,  -468,  -468,  -468,  -468,   430,   475,   294,
      20,    20,   433,  -468,  -468,   435,    20,    20,    20,    20,
      20,    20,    20,    20,  -468,   436,   446,   476,   449,   448,
     450,  -468,    20,    20,    20,    20,    20,    20,    20,    20,
    -468,  -468,   452,  -468,  -468,  -468,    20,    20,    20,    20,
      20,    20,    20,    20,  -468,   463,    20,    20,    20,    20,
      20,    20,    20,    20,   462,   464,   463,  -468,   453,   465,
      20,    20,    20,    20,    20,    20,   479,  -468,  -468,  -468,
    -468,   495,   507,    20,    20,    20,    20,   466,   508,   520,
     521,   531,   489,   488,  -468,    49,   536,   535,   540,  -468,
    -468,   500,   499,    49,   547,  -468,  -468,   503,   502,  -468,
    -468
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -468,  -468,  -468,  -468,  -468,  -468,  -468,  -468,   267,  -468,
    -468,  -468,  -468,  -468,  -468,  -468,  -468,  -468,  -468,  -468,
    -468,  -468,  -468,  -468,  -468,  -468,   273,  -468,   544,  -468,
    -468,  -468,  -468,  -468,  -468,  -468,  -468,  -468,  -468,  -468,
    -468,  -468,  -468,   338,  -468,  -468,  -468,  -468,  -468,  -468,
    -468,  -468,  -468,  -468,  -468,  -468,  -468,  -468,  -468,  -396,
    -468,  -468,  -468,  -468,  -468,  -468,  -468,  -468,  -468,  -468,
    -468,  -468,  -371,  -322,  -468,   102,  -467,  -468,  -468,  -468,
    -468,  -468,  -468,  -468,  -468,  -468,  -468,   182,  -468,   532,
    -468,   512,  -468,  -468,  -468,  -468,  -468,  -468,  -468,   122,
    -468,  -468,  -468,    -9,  -223,  -468,   -37,   -38
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -90
static const yytype_int16 yytable[] =
{
      68,    69,    70,   187,   267,   446,   365,   428,    64,    65,
     407,    64,    65,    64,    65,   511,   323,    29,   324,   325,
     454,    78,   511,    64,    65,   326,   327,    74,    75,   100,
     101,   102,   103,   323,   430,   324,   325,     9,   110,   111,
      10,   455,   326,   327,    33,   114,   116,   117,   118,    79,
     188,   364,   447,   105,    34,   106,   115,   303,   478,   336,
     479,   480,   125,   126,    12,    13,    14,   481,   432,    36,
      64,    65,   -57,   148,   135,   136,   137,    42,   138,   139,
     140,   141,   142,    64,    65,   365,   176,   147,   149,   150,
     151,    44,   -53,   510,   155,    64,   320,   158,   159,    64,
     473,   162,   163,   164,   165,   525,   166,   366,   365,   174,
      71,   177,   178,   179,    55,    58,   182,   183,    63,    82,
     184,   185,   323,    83,   324,   325,    84,   189,   190,    87,
     192,   326,   327,    89,    64,    65,   197,   181,    37,   201,
      38,   104,   204,   205,   206,   121,   208,   209,   219,   220,
     221,   222,    -8,     1,   123,   215,    39,   458,    40,    -6,
      -6,    -8,    -8,    -8,   129,   223,   245,   246,   247,    -8,
     249,   250,   130,   -89,   -13,   127,   478,   251,   479,   480,
      51,   323,    52,   324,   325,   481,    56,   128,    57,    -8,
     326,   327,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   108,   478,   109,   479,   480,   274,   275,   276,
     131,   513,   481,   280,    64,    65,    72,   200,    73,   288,
     289,   290,   291,   292,   293,   294,    64,    65,   132,   375,
      64,    65,    85,   462,    86,   133,   299,   300,   112,   119,
     113,   120,   304,   238,   252,   239,   253,   257,   134,   258,
     310,   311,   312,   313,   314,   315,   316,   259,   262,   260,
     263,   512,   319,   321,   143,   284,   337,   285,   356,   360,
     357,   361,   343,   344,   345,   346,   347,   146,   348,   349,
     152,   362,   352,   363,   354,   400,   502,   401,   503,   504,
     506,   505,   507,   508,   517,   509,   518,   144,   536,   367,
     537,   153,   154,   156,   157,   369,   370,   371,   372,   373,
     160,   374,   376,   167,   161,   168,   173,   175,   382,   383,
     384,   385,   386,   387,   388,   389,   180,   186,   194,   191,
     193,   392,   393,   394,   395,   198,   199,   202,   203,   207,
     210,   217,   212,   211,   408,   409,   410,   411,   412,   413,
     414,   415,   213,   214,   417,   418,   419,   420,   216,   241,
     240,   244,   425,   426,   242,   255,   248,   254,   261,   264,
     433,   434,   435,   436,   437,   438,   265,   268,   270,   271,
     272,   273,   448,   449,   243,   283,   277,   452,   453,   278,
     279,   -10,   281,   282,   296,   460,   461,   463,   464,   465,
     466,   297,   298,   301,   305,   317,   306,   307,   340,   338,
     322,   472,   474,   339,   350,   351,   353,   355,   358,   380,
     359,   269,   490,   491,   368,   390,   494,   396,   495,   496,
     379,   397,   391,   398,   399,   404,   406,   416,   424,   441,
     421,   423,   429,   431,   439,   440,   295,   450,   451,   492,
     493,   500,   467,   470,   468,   475,   471,   497,   520,   521,
     476,   477,   514,   499,   526,   527,   528,   529,   530,   531,
     532,   533,   515,   516,   519,   522,   523,   524,   318,   535,
     552,   534,   538,   539,   540,   597,   541,   550,   542,   543,
     544,   545,   546,   547,   548,   549,   574,   551,   553,   554,
     555,   598,   589,   564,   556,   557,   558,   559,   560,   561,
     562,   563,   586,   599,   605,   587,   590,   604,   566,   567,
     568,   569,   570,   571,   572,   573,   606,   607,   578,   579,
     580,   581,   582,   583,   378,   584,   585,   608,   609,   610,
     612,   613,   591,   592,   593,   594,   614,   595,   596,   615,
     616,   618,   619,   620,   309,   600,   601,   602,   603,   308,
      41,   489,    53,   266,    77,   469,     0,   588,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   422,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   445,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   498,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   611,     0,     0,
       0,     0,     0,     0,     0,   617
};

static const yytype_int16 yycheck[] =
{
      38,    39,    40,     4,   227,     4,   328,   403,     3,     4,
     381,     3,     4,     3,     4,   482,    16,    22,    18,    19,
      30,    23,   489,     3,     4,    25,    26,     4,     5,    67,
      68,    69,    70,    16,   405,    18,    19,     0,    76,    77,
       7,    51,    25,    26,    48,    83,    84,    85,    86,    51,
      51,    51,    51,     4,     8,     6,    51,    49,    16,    49,
      18,    19,   100,   101,     9,    10,    11,    25,    51,    50,
       3,     4,    17,     6,   112,   113,   114,    37,   116,   117,
     118,   119,   120,     3,     4,   407,     6,   125,   126,   127,
     128,    17,    37,    51,   132,     3,     4,   135,   136,     3,
       4,   139,   140,   141,   142,   501,   143,   330,   430,   147,
      50,   149,   150,   151,     4,    20,   154,   155,     4,    49,
     158,   159,    16,     6,    18,    19,     6,   164,   165,    24,
     167,    25,    26,     6,     3,     4,   174,     6,    48,   177,
      50,     6,   180,   181,   182,    34,   184,   185,    12,    13,
      14,    15,     0,     1,     6,   193,    48,    51,    50,     7,
       8,     9,    10,    11,     6,    29,   204,   205,   206,    17,
     208,   209,     6,    37,    22,     4,    16,   215,    18,    19,
      48,    16,    50,    18,    19,    25,    48,     4,    50,    37,
      25,    26,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,     4,    16,     6,    18,    19,   245,   246,   247,
       6,    51,    25,   251,     3,     4,    48,     6,    50,   257,
     258,   259,   260,   261,   262,   263,     3,     4,     6,     6,
       3,     4,    48,     6,    50,    49,   274,   275,    48,    48,
      50,    50,   280,     4,     4,     6,     6,    48,    51,    50,
     288,   289,   290,   291,   292,   293,   294,    48,    48,    50,
      50,   484,   299,   300,    48,    48,   304,    50,    48,    48,
      50,    50,   310,   311,   312,   313,   314,    51,   315,   316,
      51,    48,   319,    50,   321,    48,    48,    50,    50,    48,
      48,    50,    50,    48,     4,    50,     6,    35,     4,   337,
       6,     6,     6,    50,    50,   343,   344,   345,   346,   347,
      49,   348,   349,    48,    51,    36,    50,     4,   356,   357,
     358,   359,   360,   361,   362,   363,     6,     4,    21,    49,
      48,   369,   370,   371,   372,    51,     4,     4,     4,     4,
      49,    27,    49,    51,   382,   383,   384,   385,   386,   387,
     388,   389,    51,    49,   392,   393,   394,   395,    50,     4,
      51,     4,   400,   401,     6,    28,    51,    50,    50,    50,
     408,   409,   410,   411,   412,   413,    51,     4,    51,     4,
      49,    51,   419,   420,   202,     6,    50,   425,   426,    49,
      51,    22,    51,    51,     6,   433,   434,   435,   436,   437,
     438,    49,    51,     4,    51,    51,     6,     6,    31,    49,
      51,   448,   449,    51,    50,    49,    51,    50,    50,     4,
      50,   239,   460,   461,    50,    49,   464,     4,   465,   466,
      50,     6,    51,     4,     6,    49,    51,    50,     4,    32,
      51,    51,    50,    50,    49,    51,   264,    49,    51,     4,
       6,     4,    50,    49,    51,    49,    51,     6,   495,   496,
      51,    50,    49,    51,   502,   503,   504,   505,   506,   507,
     508,   509,    51,    51,     6,     6,    49,    51,   296,     4,
       4,    51,   520,   521,    51,     6,    51,    51,   526,   527,
     528,   529,   530,   531,   532,   533,    33,    51,    49,    51,
      50,     6,    49,    51,   542,   543,   544,   545,   546,   547,
     548,   549,    50,     6,     6,    51,    51,    51,   556,   557,
     558,   559,   560,   561,   562,   563,     6,     6,   566,   567,
     568,   569,   570,   571,   352,   572,   573,     6,    49,    51,
       4,     6,   580,   581,   582,   583,     6,   584,   585,    49,
      51,     4,    49,    51,   287,   593,   594,   595,   596,   286,
      16,   459,    30,   225,    52,   443,    -1,   576,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   397,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   417,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   472,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   605,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   613
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,    53,    54,    55,    56,    57,    60,    61,     0,
       7,    62,     9,    10,    11,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    22,
     140,   141,   142,    48,     8,    63,    50,    48,    50,    48,
      50,    80,    37,   156,    17,   113,   114,   116,   118,   120,
     122,    48,    50,   141,   144,     4,    48,    50,    20,    64,
      65,    66,    67,     4,     3,     4,   158,   159,   159,   159,
     159,    50,    48,    50,     4,     5,   143,   143,    23,    51,
     145,   146,    49,     6,     6,    48,    50,    24,    68,     6,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
     159,   159,   159,   159,     6,     4,     6,   139,     4,     6,
     159,   159,    48,    50,   159,    51,   159,   159,   159,    48,
      50,    34,    69,     6,   157,   159,   159,     4,     4,     6,
       6,     6,     6,    49,    51,   159,   159,   159,   159,   159,
     159,   159,   159,    48,    35,    70,    51,   159,     6,   159,
     159,   159,    51,     6,     6,   159,    50,    50,   159,   159,
      49,    51,   159,   159,   159,   159,   158,    48,    36,    71,
      72,    73,    74,    50,   159,     4,     6,   159,   159,   159,
       6,     6,   159,   159,   159,   159,     4,     4,    51,   158,
     158,    49,   158,    48,    21,    75,    92,   159,    51,     4,
       6,   159,     4,     4,   159,   159,   159,     4,   159,   159,
      49,    51,    49,    51,    49,   159,    50,    27,    76,    12,
      13,    14,    15,    29,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,     4,     6,
      51,     4,     6,   139,     4,   159,   159,   159,    51,   159,
     159,   159,     4,     6,    50,    28,    77,    48,    50,    48,
      50,    50,    48,    50,    50,    51,    95,   156,     4,   139,
      51,     4,    49,    51,   159,   159,   159,    50,    49,    51,
     159,    51,    51,     6,    48,    50,    58,    59,   159,   159,
     159,   159,   159,   159,   159,   139,     6,    49,    51,   159,
     159,     4,   115,    49,   159,    51,     6,     6,    78,    60,
     159,   159,   159,   159,   159,   159,   159,    51,   139,   158,
       4,   158,    51,    16,    18,    19,    25,    26,   124,   125,
     126,   132,   133,   134,   137,   138,    49,   159,    49,    51,
      31,   147,   148,   159,   159,   159,   159,   159,   158,   158,
      50,    49,   158,    51,   158,    50,    48,    50,    50,    50,
      48,    50,    48,    50,    51,   125,   156,   159,    50,   159,
     159,   159,   159,   159,   158,     6,   158,   107,   139,    50,
       4,   117,   159,   159,   159,   159,   159,   159,   159,   159,
      49,    51,   159,   159,   159,   159,     4,     6,     4,     6,
      48,    50,   111,   112,    49,   119,    51,   124,   159,   159,
     159,   159,   159,   159,   159,   159,    50,   159,   159,   159,
     159,    51,   139,    51,     4,   159,   159,   108,   111,    50,
     124,    50,    51,   159,   159,   159,   159,   159,   159,    49,
      51,    32,   149,   150,   151,   139,     4,    51,   158,   158,
      49,    51,   159,   159,    30,    51,   109,   123,    51,   121,
     159,   159,     6,   159,   159,   159,   159,    50,    51,   151,
      49,    51,   158,     4,   158,    49,    51,    50,    16,    18,
      19,    25,   127,   128,   129,   130,   131,   135,   136,   127,
     159,   159,     4,     6,   159,   158,   158,     6,   139,    51,
       4,   110,    48,    50,    48,    50,    48,    50,    48,    50,
      51,   128,   156,    51,    49,    51,    51,     4,     6,     6,
     158,   158,     6,    49,    51,   111,   159,   159,   159,   159,
     159,   159,   159,   159,    51,     4,     4,     6,   159,   159,
      51,    51,   159,   159,   159,   159,   159,   159,   159,   159,
      51,    51,     4,    49,    51,    50,   159,   159,   159,   159,
     159,   159,   159,   159,    51,   152,   159,   159,   159,   159,
     159,   159,   159,   159,    33,   153,   154,   155,   159,   159,
     159,   159,   159,   159,   158,   158,    50,    51,   155,    49,
      51,   159,   159,   159,   159,   158,   158,     6,     6,     6,
     159,   159,   159,   159,    51,     6,     6,     6,     6,    49,
      51,   139,     4,     6,     6,    49,    51,   139,     4,    49,
      51
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 5:

/* Line 1455 of yacc.c  */
#line 143 "parse_y.y"
    { YYABORT; }
    break;

  case 6:

/* Line 1455 of yacc.c  */
#line 179 "parse_y.y"
    {       /* reset flags for 'used layers';
					 * init font and data pointers
					 */
				int	i;
                file_type = PCBFILE;
				if (!yyPCB)
				{
					Message(_("illegal pcb file format\n"));
					YYABORT;
				}
				for (i = 0; i < MAX_ALL_LAYER; i++)
					LayerFlag[i] = false;
				yyFont = &yyPCB->Font;
				yyData = yyPCB->Data;
				yyData->pcb = yyPCB;
				yyData->LayerN = 0;
				/* Parse the default layer group string, just in case the file doesn't have one */
				if (ParseGroupString (Settings.Groups, &yyPCB->LayerGroups, &yyData->LayerN))
				    {
				      Message(_("illegal default layer-group string\n"));
				      YYABORT;
				    }
			}
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 215 "parse_y.y"
    {
			  PCBType *pcb_save = PCB;

			  CreateNewPCBPost (yyPCB, 0);
			/* initialize the polygon clipping now since
			 * we didn't know the layer grouping before.
			 */
			PCB = yyPCB;
			ALLPOLYGON_LOOP (yyData);
			{
			  InitClip (yyData, layer, polygon);
			}
			ENDALL_LOOP;
			PCB = pcb_save;
			}
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 234 "parse_y.y"
    {
					/* reset flags for 'used layers';
					 * init font and data pointers
					 */
				int	i;
                file_type = DATAFILE;
                /* Loading a footprint file as a layout */
				if (yyPCB)
                {
				    yyFont = &yyPCB->Font;
				    yyData = yyPCB->Data;
    				yyData->pcb = yyPCB;
                }
                /* e.g. loading data to a buffer */ 
                else if (!yyData || !yyFont)
				{
					Message(_("PCB data not initialized! Cannot load data file\n"));
					YYABORT;
				}

				for (i = 0; i < MAX_ALL_LAYER; i++)
					LayerFlag[i] = false;
				yyData->LayerN = 0;
			}
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 262 "parse_y.y"
    { 
            file_type = FONTFILE;
          }
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 270 "parse_y.y"
    {
					/* mark all symbols invalid */
				int	i;

				if (!yyFont)
				{
					Message(_("illegal file format\n"));
					YYABORT;
				}
				yyFont->Valid = false;
				for (i = 0; i <= MAX_FONTPOSITION; i++)
					free (yyFont->Symbol[i].Line);
				bzero(yyFont->Symbol, sizeof(yyFont->Symbol));
			}
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 285 "parse_y.y"
    {
				yyFont->Valid = true;
		  		SetFontInfo(yyFont);
			}
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 313 "parse_y.y"
    {
  if (check_file_version ((yyvsp[(3) - (4)].integer)) != 0)
    {
      YYABORT;
    }
}
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 352 "parse_y.y"
    {
				yyPCB->Name = (yyvsp[(3) - (4)].string);
				yyPCB->MaxWidth = MAX_COORD;
				yyPCB->MaxHeight = MAX_COORD;
			}
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 358 "parse_y.y"
    {
				yyPCB->Name = (yyvsp[(3) - (6)].string);
				yyPCB->MaxWidth = OU ((yyvsp[(4) - (6)].measure));
				yyPCB->MaxHeight = OU ((yyvsp[(5) - (6)].measure));
			}
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 364 "parse_y.y"
    {
				yyPCB->Name = (yyvsp[(3) - (6)].string);
				yyPCB->MaxWidth = NU ((yyvsp[(4) - (6)].measure));
				yyPCB->MaxHeight = NU ((yyvsp[(5) - (6)].measure));
			}
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 407 "parse_y.y"
    {
				yyPCB->Grid = OU ((yyvsp[(3) - (6)].measure));
				yyPCB->GridOffsetX = OU ((yyvsp[(4) - (6)].measure));
				yyPCB->GridOffsetY = OU ((yyvsp[(5) - (6)].measure));
			}
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 415 "parse_y.y"
    {
				yyPCB->Grid = OU ((yyvsp[(3) - (7)].measure));
				yyPCB->GridOffsetX = OU ((yyvsp[(4) - (7)].measure));
				yyPCB->GridOffsetY = OU ((yyvsp[(5) - (7)].measure));
				if ((yyvsp[(6) - (7)].integer))
					Settings.DrawGrid = true;
				else
					Settings.DrawGrid = false;
			}
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 428 "parse_y.y"
    {
				yyPCB->Grid = NU ((yyvsp[(3) - (7)].measure));
				yyPCB->GridOffsetX = NU ((yyvsp[(4) - (7)].measure));
				yyPCB->GridOffsetY = NU ((yyvsp[(5) - (7)].measure));
				if ((yyvsp[(6) - (7)].integer))
					Settings.DrawGrid = true;
				else
					Settings.DrawGrid = false;
			}
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 467 "parse_y.y"
    {
				yyPCB->CursorX = OU ((yyvsp[(3) - (6)].measure));
				yyPCB->CursorY = OU ((yyvsp[(4) - (6)].measure));
			}
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 472 "parse_y.y"
    {
				yyPCB->CursorX = NU ((yyvsp[(3) - (6)].measure));
				yyPCB->CursorY = NU ((yyvsp[(4) - (6)].measure));
			}
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 495 "parse_y.y"
    {
				/* Read in cmil^2 for now; in future this should be a noop. */
				yyPCB->IsleArea = MIL_TO_COORD (MIL_TO_COORD ((yyvsp[(3) - (4)].number)) / 100.0) / 100.0;
			}
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 522 "parse_y.y"
    {
				yyPCB->ThermScale = (yyvsp[(3) - (4)].number);
			}
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 561 "parse_y.y"
    {
				yyPCB->Bloat = NU ((yyvsp[(3) - (6)].measure));
				yyPCB->Shrink = NU ((yyvsp[(4) - (6)].measure));
				yyPCB->minWid = NU ((yyvsp[(5) - (6)].measure));
				yyPCB->minRing = NU ((yyvsp[(5) - (6)].measure));
			}
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 571 "parse_y.y"
    {
				yyPCB->Bloat = NU ((yyvsp[(3) - (7)].measure));
				yyPCB->Shrink = NU ((yyvsp[(4) - (7)].measure));
				yyPCB->minWid = NU ((yyvsp[(5) - (7)].measure));
				yyPCB->minSlk = NU ((yyvsp[(6) - (7)].measure));
				yyPCB->minRing = NU ((yyvsp[(5) - (7)].measure));
			}
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 582 "parse_y.y"
    {
				yyPCB->Bloat = NU ((yyvsp[(3) - (9)].measure));
				yyPCB->Shrink = NU ((yyvsp[(4) - (9)].measure));
				yyPCB->minWid = NU ((yyvsp[(5) - (9)].measure));
				yyPCB->minSlk = NU ((yyvsp[(6) - (9)].measure));
				yyPCB->minDrill = NU ((yyvsp[(7) - (9)].measure));
				yyPCB->minRing = NU ((yyvsp[(8) - (9)].measure));
			}
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 609 "parse_y.y"
    {
				yyPCB->Flags = MakeFlags ((yyvsp[(3) - (4)].integer) & PCB_FLAGS);
			}
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 613 "parse_y.y"
    {
			  yyPCB->Flags = string_to_pcbflags ((yyvsp[(3) - (4)].string), yyerror);
                          free ((yyvsp[(3) - (4)].string));
			}
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 646 "parse_y.y"
    {
			  if (ParseGroupString ((yyvsp[(3) - (4)].string), &yyPCB->LayerGroups, &yyData->LayerN))
			    {
			      Message(_("illegal layer-group string\n"));
			      YYABORT;
			    }
                            free ((yyvsp[(3) - (4)].string));
			}
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 711 "parse_y.y"
    {
				if (ParseRouteString(((yyvsp[(3) - (4)].string) == NULL ? "" : (yyvsp[(3) - (4)].string)), &yyPCB->RouteStyle[0], "mil"))
				{
					Message(_("illegal route-style string\n"));
					YYABORT;
				}
                                free ((yyvsp[(3) - (4)].string));
			}
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 720 "parse_y.y"
    {
				if (ParseRouteString(((yyvsp[(3) - (4)].string) == NULL ? "" : (yyvsp[(3) - (4)].string)), &yyPCB->RouteStyle[0], "cmil"))
				{
					Message(_("illegal route-style string\n"));
					YYABORT;
				}
                                free ((yyvsp[(3) - (4)].string));
			}
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 743 "parse_y.y"
    { attr_list = & yyPCB->Attributes; }
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 746 "parse_y.y"
    {
            if ( file_type == DATAFILE ) {
 
		      if (yyPCB != NULL)
		        {
			  /* This case is when we load a footprint with file->open, or from the command line */
			  yyFont = &yyPCB->Font;
			  yyData = yyPCB->Data;
			  yyData->pcb = yyPCB;
			  yyData->LayerN = 0;
		        }
		    }
          }
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 760 "parse_y.y"
    {
            if (file_type == DATAFILE){
		      PCBType *pcb_save = PCB;
		      ElementType *e;
		      if (yyPCB != NULL)
		        {
			  /* This case is when we load a footprint with file->open, or from the command line */
			  CreateNewPCBPost (yyPCB, 0);
			  ParseGroupString("1,c:2,s", &yyPCB->LayerGroups, &yyData->LayerN);
			  e = yyPCB->Data->Element->data; /* we know there's only one */
			  PCB = yyPCB;
			  MoveElementLowLevel (yyPCB->Data, e, -e->BoundingBox.X1, -e->BoundingBox.Y1);
			  PCB = pcb_save;
			  yyPCB->MaxWidth = e->BoundingBox.X2;
			  yyPCB->MaxHeight = e->BoundingBox.Y2;
			  yyPCB->is_footprint = 1;
		        }
            }
		  }
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 852 "parse_y.y"
    {
				CreateNewViaEx (yyData, NU ((yyvsp[(3) - (13)].measure)), NU ((yyvsp[(4) - (13)].measure)), NU ((yyvsp[(5) - (13)].measure)), NU ((yyvsp[(6) - (13)].measure)), NU ((yyvsp[(7) - (13)].measure)),
						     NU ((yyvsp[(8) - (13)].measure)), (yyvsp[(11) - (13)].string), (yyvsp[(12) - (13)].flagtype), (yyvsp[(9) - (13)].integer), (yyvsp[(10) - (13)].integer));
				free ((yyvsp[(11) - (13)].string));
			}
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 862 "parse_y.y"
    {
				CreateNewVia(yyData, NU ((yyvsp[(3) - (11)].measure)), NU ((yyvsp[(4) - (11)].measure)), NU ((yyvsp[(5) - (11)].measure)), NU ((yyvsp[(6) - (11)].measure)), NU ((yyvsp[(7) - (11)].measure)),
				                     NU ((yyvsp[(8) - (11)].measure)), (yyvsp[(9) - (11)].string), (yyvsp[(10) - (11)].flagtype));
				free ((yyvsp[(9) - (11)].string));
			}
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 872 "parse_y.y"
    {
				CreateNewVia(yyData, OU ((yyvsp[(3) - (11)].measure)), OU ((yyvsp[(4) - (11)].measure)), OU ((yyvsp[(5) - (11)].measure)), OU ((yyvsp[(6) - (11)].measure)), OU ((yyvsp[(7) - (11)].measure)), OU ((yyvsp[(8) - (11)].measure)), (yyvsp[(9) - (11)].string),
					OldFlags((yyvsp[(10) - (11)].integer)));
				free ((yyvsp[(9) - (11)].string));
			}
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 883 "parse_y.y"
    {
				CreateNewVia(yyData, OU ((yyvsp[(3) - (10)].measure)), OU ((yyvsp[(4) - (10)].measure)), OU ((yyvsp[(5) - (10)].measure)), OU ((yyvsp[(6) - (10)].measure)),
					     OU ((yyvsp[(5) - (10)].measure)) + OU((yyvsp[(6) - (10)].measure)), OU ((yyvsp[(7) - (10)].measure)), (yyvsp[(8) - (10)].string), OldFlags((yyvsp[(9) - (10)].integer)));
				free ((yyvsp[(8) - (10)].string));
			}
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 893 "parse_y.y"
    {
				CreateNewVia(yyData, OU ((yyvsp[(3) - (9)].measure)), OU ((yyvsp[(4) - (9)].measure)), OU ((yyvsp[(5) - (9)].measure)), 2*GROUNDPLANEFRAME,
					OU((yyvsp[(5) - (9)].measure)) + 2*MASKFRAME,  OU ((yyvsp[(6) - (9)].measure)), (yyvsp[(7) - (9)].string), OldFlags((yyvsp[(8) - (9)].integer)));
				free ((yyvsp[(7) - (9)].string));
			}
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 903 "parse_y.y"
    {
				Coord	hole = (OU((yyvsp[(5) - (8)].measure)) * DEFAULT_DRILLINGHOLE);

				CreateNewVia(yyData, OU ((yyvsp[(3) - (8)].measure)), OU ((yyvsp[(4) - (8)].measure)), OU ((yyvsp[(5) - (8)].measure)), 2*GROUNDPLANEFRAME,
					OU((yyvsp[(5) - (8)].measure)) + 2*MASKFRAME, hole, (yyvsp[(6) - (8)].string), OldFlags((yyvsp[(7) - (8)].integer)));
				free ((yyvsp[(6) - (8)].string));
			}
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 943 "parse_y.y"
    {
				CreateNewRat(yyData, NU ((yyvsp[(3) - (10)].measure)), NU ((yyvsp[(4) - (10)].measure)), NU ((yyvsp[(6) - (10)].measure)), NU ((yyvsp[(7) - (10)].measure)), (yyvsp[(5) - (10)].integer), (yyvsp[(8) - (10)].integer),
					Settings.RatThickness, (yyvsp[(9) - (10)].flagtype));
			}
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 948 "parse_y.y"
    {
				CreateNewRat(yyData, OU ((yyvsp[(3) - (10)].measure)), OU ((yyvsp[(4) - (10)].measure)), OU ((yyvsp[(6) - (10)].measure)), OU ((yyvsp[(7) - (10)].measure)), (yyvsp[(5) - (10)].integer), (yyvsp[(8) - (10)].integer),
					Settings.RatThickness, OldFlags((yyvsp[(9) - (10)].integer)));
			}
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 991 "parse_y.y"
    {
				if ((yyvsp[(3) - (7)].integer) <= 0 || (yyvsp[(3) - (7)].integer) > MAX_ALL_LAYER)
				{
					yyerror("Layernumber out of range");
					YYABORT;
				}
				if (LayerFlag[(yyvsp[(3) - (7)].integer)-1])
				{
					yyerror("Layernumber used twice");
					YYABORT;
				}
				Layer = &yyData->Layer[(yyvsp[(3) - (7)].integer)-1];

                                /* memory for name is already allocated */
				Layer->Name = (yyvsp[(4) - (7)].string);
                         	if (Layer->Name == NULL)
                                   Layer->Name = strdup("");
				LayerFlag[(yyvsp[(3) - (7)].integer)-1] = true;
                                if ((yyvsp[(5) - (7)].string))
                                  Layer->Type = string_to_layertype ((yyvsp[(5) - (7)].string), yyerror);
                                else
                                  Layer->Type = guess_layertype ((yyvsp[(4) - (7)].string), (yyvsp[(3) - (7)].integer), yyData);
                                if ((yyvsp[(5) - (7)].string) != NULL)
                                  free ((yyvsp[(5) - (7)].string));
			}
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 1038 "parse_y.y"
    {
				CreateNewPolygonFromRectangle(Layer,
					OU ((yyvsp[(3) - (8)].measure)), OU ((yyvsp[(4) - (8)].measure)), OU ((yyvsp[(3) - (8)].measure)) + OU ((yyvsp[(5) - (8)].measure)), OU ((yyvsp[(4) - (8)].measure)) + OU ((yyvsp[(6) - (8)].measure)), OldFlags((yyvsp[(7) - (8)].integer)));
			}
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 1045 "parse_y.y"
    { attr_list = & Layer->Attributes; }
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 1086 "parse_y.y"
    {
				CreateNewLineOnLayer(Layer, NU ((yyvsp[(3) - (10)].measure)), NU ((yyvsp[(4) - (10)].measure)), NU ((yyvsp[(5) - (10)].measure)), NU ((yyvsp[(6) - (10)].measure)),
				                            NU ((yyvsp[(7) - (10)].measure)), NU ((yyvsp[(8) - (10)].measure)), (yyvsp[(9) - (10)].flagtype));
			}
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 1095 "parse_y.y"
    {
				CreateNewLineOnLayer(Layer, OU ((yyvsp[(3) - (10)].measure)), OU ((yyvsp[(4) - (10)].measure)), OU ((yyvsp[(5) - (10)].measure)), OU ((yyvsp[(6) - (10)].measure)),
						     OU ((yyvsp[(7) - (10)].measure)), OU ((yyvsp[(8) - (10)].measure)), OldFlags((yyvsp[(9) - (10)].integer)));
			}
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 1104 "parse_y.y"
    {
				/* eliminate old-style rat-lines */
			if ((IV ((yyvsp[(8) - (9)].measure)) & RATFLAG) == 0)
				CreateNewLineOnLayer(Layer, OU ((yyvsp[(3) - (9)].measure)), OU ((yyvsp[(4) - (9)].measure)), OU ((yyvsp[(5) - (9)].measure)), OU ((yyvsp[(6) - (9)].measure)), OU ((yyvsp[(7) - (9)].measure)),
					200*GROUNDPLANEFRAME, OldFlags(IV ((yyvsp[(8) - (9)].measure))));
			}
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 1161 "parse_y.y"
    {
			  CreateNewArcOnLayer(Layer, NU ((yyvsp[(3) - (12)].measure)), NU ((yyvsp[(4) - (12)].measure)), NU ((yyvsp[(5) - (12)].measure)), NU ((yyvsp[(6) - (12)].measure)), (yyvsp[(9) - (12)].number), (yyvsp[(10) - (12)].number),
			                             NU ((yyvsp[(7) - (12)].measure)), NU ((yyvsp[(8) - (12)].measure)), (yyvsp[(11) - (12)].flagtype));
			}
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 1170 "parse_y.y"
    {
				CreateNewArcOnLayer(Layer, OU ((yyvsp[(3) - (12)].measure)), OU ((yyvsp[(4) - (12)].measure)), OU ((yyvsp[(5) - (12)].measure)), OU ((yyvsp[(6) - (12)].measure)), (yyvsp[(9) - (12)].number), (yyvsp[(10) - (12)].number),
						    OU ((yyvsp[(7) - (12)].measure)), OU ((yyvsp[(8) - (12)].measure)), OldFlags((yyvsp[(11) - (12)].integer)));
			}
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 1179 "parse_y.y"
    {
				CreateNewArcOnLayer(Layer, OU ((yyvsp[(3) - (11)].measure)), OU ((yyvsp[(4) - (11)].measure)), OU ((yyvsp[(5) - (11)].measure)), OU ((yyvsp[(5) - (11)].measure)), IV ((yyvsp[(8) - (11)].measure)), (yyvsp[(9) - (11)].number),
					OU ((yyvsp[(7) - (11)].measure)), 200*GROUNDPLANEFRAME, OldFlags((yyvsp[(10) - (11)].integer)));
			}
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 1225 "parse_y.y"
    {
					/* use a default scale of 100% */
				CreateNewText(Layer,yyFont,OU ((yyvsp[(3) - (8)].measure)), OU ((yyvsp[(4) - (8)].measure)), (yyvsp[(5) - (8)].number), 100, (yyvsp[(6) - (8)].string), OldFlags((yyvsp[(7) - (8)].integer)));
				free ((yyvsp[(6) - (8)].string));
			}
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 1235 "parse_y.y"
    {
				if ((yyvsp[(8) - (9)].integer) & ONSILKFLAG)
				{
					LayerType *lay = &yyData->Layer[yyData->LayerN +
						(((yyvsp[(8) - (9)].integer) & ONSOLDERFLAG) ? BOTTOM_SILK_LAYER : TOP_SILK_LAYER)];

					CreateNewText(lay ,yyFont, OU ((yyvsp[(3) - (9)].measure)), OU ((yyvsp[(4) - (9)].measure)), (yyvsp[(5) - (9)].number), (yyvsp[(6) - (9)].number), (yyvsp[(7) - (9)].string),
						      OldFlags((yyvsp[(8) - (9)].integer)));
				}
				else
					CreateNewText(Layer, yyFont, OU ((yyvsp[(3) - (9)].measure)), OU ((yyvsp[(4) - (9)].measure)), (yyvsp[(5) - (9)].number), (yyvsp[(6) - (9)].number), (yyvsp[(7) - (9)].string),
						      OldFlags((yyvsp[(8) - (9)].integer)));
				free ((yyvsp[(7) - (9)].string));
			}
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 1253 "parse_y.y"
    {
				/* FIXME: shouldn't know about .f */
				/* I don't think this matters because anything with hi_format
				 * will have the silk on its own layer in the file rather
				 * than using the ONSILKFLAG and having it in a copper layer.
				 * Thus there is no need for anything besides the 'else'
				 * part of this code.
				 */
				if ((yyvsp[(8) - (9)].flagtype).f & ONSILKFLAG)
				{
					LayerType *lay = &yyData->Layer[yyData->LayerN +
						(((yyvsp[(8) - (9)].flagtype).f & ONSOLDERFLAG) ? BOTTOM_SILK_LAYER : TOP_SILK_LAYER)];

					CreateNewText(lay, yyFont, NU ((yyvsp[(3) - (9)].measure)), NU ((yyvsp[(4) - (9)].measure)), (yyvsp[(5) - (9)].number), (yyvsp[(6) - (9)].number), (yyvsp[(7) - (9)].string), (yyvsp[(8) - (9)].flagtype));
				}
				else
					CreateNewText(Layer, yyFont, NU ((yyvsp[(3) - (9)].measure)), NU ((yyvsp[(4) - (9)].measure)), (yyvsp[(5) - (9)].number), (yyvsp[(6) - (9)].number), (yyvsp[(7) - (9)].string), (yyvsp[(8) - (9)].flagtype));
				free ((yyvsp[(7) - (9)].string));
			}
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 1316 "parse_y.y"
    {
				Polygon = CreateNewPolygon(Layer, (yyvsp[(3) - (5)].flagtype));
			}
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 1321 "parse_y.y"
    {
				Cardinal contour, contour_start, contour_end;
				bool bad_contour_found = false;
				/* ignore junk */
				for (contour = 0; contour <= Polygon->HoleIndexN; contour++)
				  {
				    contour_start = (contour == 0) ?
						      0 : Polygon->HoleIndex[contour - 1];
				    contour_end = (contour == Polygon->HoleIndexN) ?
						 Polygon->PointN :
						 Polygon->HoleIndex[contour];
				    if (contour_end - contour_start < 3)
				      bad_contour_found = true;
				  }

				if (bad_contour_found)
				  {
				    Message(_("WARNING parsing file '%s'\n"
					    "    line:        %i\n"
					    "    description: 'ignored polygon "
					    "(< 3 points in a contour)'\n"),
					    yyfilename, yylineno);
				    DestroyObject(yyData, POLYGON_TYPE, Layer, Polygon, Polygon);
				  }
				else
				  {
				    SetPolygonBoundingBox (Polygon);
				    if (!Layer->polygon_tree)
				      Layer->polygon_tree = r_create_tree (NULL, 0, 0);
				    r_insert_entry (Layer->polygon_tree, (BoxType *) Polygon, 0);
				  }
			}
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 1362 "parse_y.y"
    {
				CreateNewHoleInPolygon (Polygon);
			}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 1376 "parse_y.y"
    {
				CreateNewPointInPolygon(Polygon, OU ((yyvsp[(2) - (4)].measure)), OU ((yyvsp[(3) - (4)].measure)));
			}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 1380 "parse_y.y"
    {
				CreateNewPointInPolygon(Polygon, NU ((yyvsp[(2) - (4)].measure)), NU ((yyvsp[(3) - (4)].measure)));
			}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 1462 "parse_y.y"
    {
				yyElement = CreateNewElement(yyData, yyFont, NoFlags(),
					(yyvsp[(3) - (9)].string), (yyvsp[(4) - (9)].string), NULL, OU ((yyvsp[(5) - (9)].measure)), OU ((yyvsp[(6) - (9)].measure)), (yyvsp[(7) - (9)].integer), 100, NoFlags(), false);
				free ((yyvsp[(3) - (9)].string));
				free ((yyvsp[(4) - (9)].string));
				pin_num = 1;
			}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 1470 "parse_y.y"
    {
				SetElementBoundingBox(yyData, yyElement, yyFont);
			}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 1480 "parse_y.y"
    {
				yyElement = CreateNewElement(yyData, yyFont, OldFlags((yyvsp[(3) - (12)].integer)),
					(yyvsp[(4) - (12)].string), (yyvsp[(5) - (12)].string), NULL, OU ((yyvsp[(6) - (12)].measure)), OU ((yyvsp[(7) - (12)].measure)), IV ((yyvsp[(8) - (12)].measure)), IV ((yyvsp[(9) - (12)].measure)), OldFlags((yyvsp[(10) - (12)].integer)), false);
				free ((yyvsp[(4) - (12)].string));
				free ((yyvsp[(5) - (12)].string));
				pin_num = 1;
			}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 1488 "parse_y.y"
    {
				SetElementBoundingBox(yyData, yyElement, yyFont);
			}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 1498 "parse_y.y"
    {
				yyElement = CreateNewElement(yyData, yyFont, OldFlags((yyvsp[(3) - (13)].integer)),
					(yyvsp[(4) - (13)].string), (yyvsp[(5) - (13)].string), (yyvsp[(6) - (13)].string), OU ((yyvsp[(7) - (13)].measure)), OU ((yyvsp[(8) - (13)].measure)), IV ((yyvsp[(9) - (13)].measure)), IV ((yyvsp[(10) - (13)].measure)), OldFlags((yyvsp[(11) - (13)].integer)), false);
				free ((yyvsp[(4) - (13)].string));
				free ((yyvsp[(5) - (13)].string));
				free ((yyvsp[(6) - (13)].string));
				pin_num = 1;
			}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 1507 "parse_y.y"
    {
				SetElementBoundingBox(yyData, yyElement, yyFont);
			}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 1518 "parse_y.y"
    {
				yyElement = CreateNewElement(yyData, yyFont, OldFlags((yyvsp[(3) - (15)].integer)),
					(yyvsp[(4) - (15)].string), (yyvsp[(5) - (15)].string), (yyvsp[(6) - (15)].string), OU ((yyvsp[(7) - (15)].measure)) + OU ((yyvsp[(9) - (15)].measure)), OU ((yyvsp[(8) - (15)].measure)) + OU ((yyvsp[(10) - (15)].measure)),
					(yyvsp[(11) - (15)].number), (yyvsp[(12) - (15)].number), OldFlags((yyvsp[(13) - (15)].integer)), false);
				yyElement->MarkX = OU ((yyvsp[(7) - (15)].measure));
				yyElement->MarkY = OU ((yyvsp[(8) - (15)].measure));
				free ((yyvsp[(4) - (15)].string));
				free ((yyvsp[(5) - (15)].string));
				free ((yyvsp[(6) - (15)].string));
			}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 1529 "parse_y.y"
    {
				SetElementBoundingBox(yyData, yyElement, yyFont);
			}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 1540 "parse_y.y"
    {
				yyElement = CreateNewElement(yyData, yyFont, (yyvsp[(3) - (15)].flagtype),
					(yyvsp[(4) - (15)].string), (yyvsp[(5) - (15)].string), (yyvsp[(6) - (15)].string), NU ((yyvsp[(7) - (15)].measure)) + NU ((yyvsp[(9) - (15)].measure)), NU ((yyvsp[(8) - (15)].measure)) + NU ((yyvsp[(10) - (15)].measure)),
					(yyvsp[(11) - (15)].number), (yyvsp[(12) - (15)].number), (yyvsp[(13) - (15)].flagtype), false);
				yyElement->MarkX = NU ((yyvsp[(7) - (15)].measure));
				yyElement->MarkY = NU ((yyvsp[(8) - (15)].measure));
				free ((yyvsp[(4) - (15)].string));
				free ((yyvsp[(5) - (15)].string));
				free ((yyvsp[(6) - (15)].string));
			}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 1551 "parse_y.y"
    {
				SetElementBoundingBox(yyData, yyElement, yyFont);
			}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 1652 "parse_y.y"
    {
				CreateNewLineInElement(yyElement, NU ((yyvsp[(3) - (8)].measure)), NU ((yyvsp[(4) - (8)].measure)), NU ((yyvsp[(5) - (8)].measure)), NU ((yyvsp[(6) - (8)].measure)), NU ((yyvsp[(7) - (8)].measure)));
			}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 1657 "parse_y.y"
    {
				CreateNewLineInElement(yyElement, OU ((yyvsp[(3) - (8)].measure)), OU ((yyvsp[(4) - (8)].measure)), OU ((yyvsp[(5) - (8)].measure)), OU ((yyvsp[(6) - (8)].measure)), OU ((yyvsp[(7) - (8)].measure)));
			}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 1662 "parse_y.y"
    {
				CreateNewArcInElement(yyElement, NU ((yyvsp[(3) - (10)].measure)), NU ((yyvsp[(4) - (10)].measure)), NU ((yyvsp[(5) - (10)].measure)), NU ((yyvsp[(6) - (10)].measure)), (yyvsp[(7) - (10)].number), (yyvsp[(8) - (10)].number), NU ((yyvsp[(9) - (10)].measure)));
			}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 1667 "parse_y.y"
    {
				CreateNewArcInElement(yyElement, OU ((yyvsp[(3) - (10)].measure)), OU ((yyvsp[(4) - (10)].measure)), OU ((yyvsp[(5) - (10)].measure)), OU ((yyvsp[(6) - (10)].measure)), (yyvsp[(7) - (10)].number), (yyvsp[(8) - (10)].number), OU ((yyvsp[(9) - (10)].measure)));
			}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 1672 "parse_y.y"
    {
				yyElement->MarkX = NU ((yyvsp[(3) - (5)].measure));
				yyElement->MarkY = NU ((yyvsp[(4) - (5)].measure));
			}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 1677 "parse_y.y"
    {
				yyElement->MarkX = OU ((yyvsp[(3) - (5)].measure));
				yyElement->MarkY = OU ((yyvsp[(4) - (5)].measure));
			}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 1681 "parse_y.y"
    { attr_list = & yyElement->Attributes; }
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 1696 "parse_y.y"
    {
				CreateNewLineInElement(yyElement, NU ((yyvsp[(3) - (8)].measure)) + yyElement->MarkX,
					NU ((yyvsp[(4) - (8)].measure)) + yyElement->MarkY, NU ((yyvsp[(5) - (8)].measure)) + yyElement->MarkX,
					NU ((yyvsp[(6) - (8)].measure)) + yyElement->MarkY, NU ((yyvsp[(7) - (8)].measure)));
			}
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 1702 "parse_y.y"
    {
				CreateNewLineInElement(yyElement, OU ((yyvsp[(3) - (8)].measure)) + yyElement->MarkX,
					OU ((yyvsp[(4) - (8)].measure)) + yyElement->MarkY, OU ((yyvsp[(5) - (8)].measure)) + yyElement->MarkX,
					OU ((yyvsp[(6) - (8)].measure)) + yyElement->MarkY, OU ((yyvsp[(7) - (8)].measure)));
			}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 1709 "parse_y.y"
    {
				CreateNewArcInElement(yyElement, NU ((yyvsp[(3) - (10)].measure)) + yyElement->MarkX,
					NU ((yyvsp[(4) - (10)].measure)) + yyElement->MarkY, NU ((yyvsp[(5) - (10)].measure)), NU ((yyvsp[(6) - (10)].measure)), (yyvsp[(7) - (10)].number), (yyvsp[(8) - (10)].number), NU ((yyvsp[(9) - (10)].measure)));
			}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 1714 "parse_y.y"
    {
				CreateNewArcInElement(yyElement, OU ((yyvsp[(3) - (10)].measure)) + yyElement->MarkX,
					OU ((yyvsp[(4) - (10)].measure)) + yyElement->MarkY, OU ((yyvsp[(5) - (10)].measure)), OU ((yyvsp[(6) - (10)].measure)), (yyvsp[(7) - (10)].number), (yyvsp[(8) - (10)].number), OU ((yyvsp[(9) - (10)].measure)));
			}
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 1718 "parse_y.y"
    { attr_list = & yyElement->Attributes; }
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 1769 "parse_y.y"
    {
				CreateNewPin(yyElement, NU ((yyvsp[(3) - (12)].measure)) + yyElement->MarkX,
					NU ((yyvsp[(4) - (12)].measure)) + yyElement->MarkY, NU ((yyvsp[(5) - (12)].measure)), NU ((yyvsp[(6) - (12)].measure)), NU ((yyvsp[(7) - (12)].measure)), NU ((yyvsp[(8) - (12)].measure)), (yyvsp[(9) - (12)].string),
					(yyvsp[(10) - (12)].string), (yyvsp[(11) - (12)].flagtype));
				free ((yyvsp[(9) - (12)].string));
				free ((yyvsp[(10) - (12)].string));
			}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 1781 "parse_y.y"
    {
				CreateNewPin(yyElement, OU ((yyvsp[(3) - (12)].measure)) + yyElement->MarkX,
					OU ((yyvsp[(4) - (12)].measure)) + yyElement->MarkY, OU ((yyvsp[(5) - (12)].measure)), OU ((yyvsp[(6) - (12)].measure)), OU ((yyvsp[(7) - (12)].measure)), OU ((yyvsp[(8) - (12)].measure)), (yyvsp[(9) - (12)].string),
					(yyvsp[(10) - (12)].string), OldFlags((yyvsp[(11) - (12)].integer)));
				free ((yyvsp[(9) - (12)].string));
				free ((yyvsp[(10) - (12)].string));
			}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 1793 "parse_y.y"
    {
				CreateNewPin(yyElement, OU ((yyvsp[(3) - (10)].measure)), OU ((yyvsp[(4) - (10)].measure)), OU ((yyvsp[(5) - (10)].measure)), 2*GROUNDPLANEFRAME,
					OU ((yyvsp[(5) - (10)].measure)) + 2*MASKFRAME, OU ((yyvsp[(6) - (10)].measure)), (yyvsp[(7) - (10)].string), (yyvsp[(8) - (10)].string), OldFlags((yyvsp[(9) - (10)].integer)));
				free ((yyvsp[(7) - (10)].string));
				free ((yyvsp[(8) - (10)].string));
			}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 1804 "parse_y.y"
    {
				char	p_number[8];

				sprintf(p_number, "%d", pin_num++);
				CreateNewPin(yyElement, OU ((yyvsp[(3) - (9)].measure)), OU ((yyvsp[(4) - (9)].measure)), OU ((yyvsp[(5) - (9)].measure)), 2*GROUNDPLANEFRAME,
					OU ((yyvsp[(5) - (9)].measure)) + 2*MASKFRAME, OU ((yyvsp[(6) - (9)].measure)), (yyvsp[(7) - (9)].string), p_number, OldFlags((yyvsp[(8) - (9)].integer)));

				free ((yyvsp[(7) - (9)].string));
			}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 1820 "parse_y.y"
    {
				Coord	hole = OU ((yyvsp[(5) - (8)].measure)) * DEFAULT_DRILLINGHOLE;
				char	p_number[8];

				sprintf(p_number, "%d", pin_num++);
				CreateNewPin(yyElement, OU ((yyvsp[(3) - (8)].measure)), OU ((yyvsp[(4) - (8)].measure)), OU ((yyvsp[(5) - (8)].measure)), 2*GROUNDPLANEFRAME,
					OU ((yyvsp[(5) - (8)].measure)) + 2*MASKFRAME, hole, (yyvsp[(6) - (8)].string), p_number, OldFlags((yyvsp[(7) - (8)].integer)));
				free ((yyvsp[(6) - (8)].string));
			}
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 1878 "parse_y.y"
    {
				CreateNewPad(yyElement, NU ((yyvsp[(3) - (13)].measure)) + yyElement->MarkX,
					NU ((yyvsp[(4) - (13)].measure)) + yyElement->MarkY,
					NU ((yyvsp[(5) - (13)].measure)) + yyElement->MarkX,
					NU ((yyvsp[(6) - (13)].measure)) + yyElement->MarkY, NU ((yyvsp[(7) - (13)].measure)), NU ((yyvsp[(8) - (13)].measure)), NU ((yyvsp[(9) - (13)].measure)),
					(yyvsp[(10) - (13)].string), (yyvsp[(11) - (13)].string), (yyvsp[(12) - (13)].flagtype));
				free ((yyvsp[(10) - (13)].string));
				free ((yyvsp[(11) - (13)].string));
			}
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 1892 "parse_y.y"
    {
				CreateNewPad(yyElement,OU ((yyvsp[(3) - (13)].measure)) + yyElement->MarkX,
					OU ((yyvsp[(4) - (13)].measure)) + yyElement->MarkY, OU ((yyvsp[(5) - (13)].measure)) + yyElement->MarkX,
					OU ((yyvsp[(6) - (13)].measure)) + yyElement->MarkY, OU ((yyvsp[(7) - (13)].measure)), OU ((yyvsp[(8) - (13)].measure)), OU ((yyvsp[(9) - (13)].measure)),
					(yyvsp[(10) - (13)].string), (yyvsp[(11) - (13)].string), OldFlags((yyvsp[(12) - (13)].integer)));
				free ((yyvsp[(10) - (13)].string));
				free ((yyvsp[(11) - (13)].string));
			}
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 1905 "parse_y.y"
    {
				CreateNewPad(yyElement,OU ((yyvsp[(3) - (11)].measure)),OU ((yyvsp[(4) - (11)].measure)),OU ((yyvsp[(5) - (11)].measure)),OU ((yyvsp[(6) - (11)].measure)),OU ((yyvsp[(7) - (11)].measure)), 2*GROUNDPLANEFRAME,
					OU ((yyvsp[(7) - (11)].measure)) + 2*MASKFRAME, (yyvsp[(8) - (11)].string), (yyvsp[(9) - (11)].string), OldFlags((yyvsp[(10) - (11)].integer)));
				free ((yyvsp[(8) - (11)].string));
				free ((yyvsp[(9) - (11)].string));
			}
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 1916 "parse_y.y"
    {
				char		p_number[8];

				sprintf(p_number, "%d", pin_num++);
				CreateNewPad(yyElement,OU ((yyvsp[(3) - (10)].measure)),OU ((yyvsp[(4) - (10)].measure)),OU ((yyvsp[(5) - (10)].measure)),OU ((yyvsp[(6) - (10)].measure)),OU ((yyvsp[(7) - (10)].measure)), 2*GROUNDPLANEFRAME,
					OU ((yyvsp[(7) - (10)].measure)) + 2*MASKFRAME, (yyvsp[(8) - (10)].string),p_number, OldFlags((yyvsp[(9) - (10)].integer)));
				free ((yyvsp[(8) - (10)].string));
			}
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 1926 "parse_y.y"
    { (yyval.flagtype) = OldFlags((yyvsp[(1) - (1)].integer)); }
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 1927 "parse_y.y"
    { (yyval.flagtype) = string_to_flags ((yyvsp[(1) - (1)].string), yyerror); free((yyvsp[(1) - (1)].string)); }
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 1968 "parse_y.y"
    {
				if ((yyvsp[(3) - (6)].integer) <= 0 || (yyvsp[(3) - (6)].integer) > MAX_FONTPOSITION)
				{
					yyerror("fontposition out of range");
					YYABORT;
				}
				Symbol = &yyFont->Symbol[(yyvsp[(3) - (6)].integer)];
				if (Symbol->Valid)
				{
					yyerror("symbol ID used twice");
					YYABORT;
				}
				Symbol->Valid = true;
				Symbol->Delta = NU ((yyvsp[(4) - (6)].measure));
			}
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 1984 "parse_y.y"
    {
				if ((yyvsp[(3) - (6)].integer) <= 0 || (yyvsp[(3) - (6)].integer) > MAX_FONTPOSITION)
				{
					yyerror("fontposition out of range");
					YYABORT;
				}
				Symbol = &yyFont->Symbol[(yyvsp[(3) - (6)].integer)];
				if (Symbol->Valid)
				{
					yyerror("symbol ID used twice");
					YYABORT;
				}
				Symbol->Valid = true;
				Symbol->Delta = OU ((yyvsp[(4) - (6)].measure));
			}
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 2040 "parse_y.y"
    {
				CreateNewLineInSymbol(Symbol, OU ((yyvsp[(3) - (8)].measure)), OU ((yyvsp[(4) - (8)].measure)), OU ((yyvsp[(5) - (8)].measure)), OU ((yyvsp[(6) - (8)].measure)), OU ((yyvsp[(7) - (8)].measure)));
			}
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 2047 "parse_y.y"
    {
				CreateNewLineInSymbol(Symbol, NU ((yyvsp[(3) - (8)].measure)), NU ((yyvsp[(4) - (8)].measure)), NU ((yyvsp[(5) - (8)].measure)), NU ((yyvsp[(6) - (8)].measure)), NU ((yyvsp[(7) - (8)].measure)));
			}
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 2101 "parse_y.y"
    {
				Menu = CreateNewNet(&yyPCB->NetlistLib, (yyvsp[(3) - (6)].string), (yyvsp[(4) - (6)].string));
				free ((yyvsp[(3) - (6)].string));
				free ((yyvsp[(4) - (6)].string));
			}
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 2136 "parse_y.y"
    {
				CreateNewConnection(Menu, (yyvsp[(3) - (4)].string));
				free ((yyvsp[(3) - (4)].string));
			}
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 2195 "parse_y.y"
    {
			  CreateNewAttribute (attr_list, (yyvsp[(3) - (5)].string), (yyvsp[(4) - (5)].string) ? (yyvsp[(4) - (5)].string) : (char *)"");
				free ((yyvsp[(3) - (5)].string));
				free ((yyvsp[(4) - (5)].string));
			}
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 2202 "parse_y.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); }
    break;

  case 192:

/* Line 1455 of yacc.c  */
#line 2203 "parse_y.y"
    { (yyval.string) = 0; }
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 2207 "parse_y.y"
    { (yyval.number) = (yyvsp[(1) - (1)].number); }
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 2208 "parse_y.y"
    { (yyval.number) = (yyvsp[(1) - (1)].integer); }
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 2213 "parse_y.y"
    { do_measure(&(yyval.measure), (yyvsp[(1) - (1)].number), MIL_TO_COORD ((yyvsp[(1) - (1)].number)) / 100.0, 0); }
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 2214 "parse_y.y"
    { M ((yyval.measure), (yyvsp[(1) - (2)].number), MIL_TO_COORD ((yyvsp[(1) - (2)].number)) / 1000000.0); }
    break;

  case 197:

/* Line 1455 of yacc.c  */
#line 2215 "parse_y.y"
    { M ((yyval.measure), (yyvsp[(1) - (2)].number), MIL_TO_COORD ((yyvsp[(1) - (2)].number)) / 100.0); }
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 2216 "parse_y.y"
    { M ((yyval.measure), (yyvsp[(1) - (2)].number), MIL_TO_COORD ((yyvsp[(1) - (2)].number))); }
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 2217 "parse_y.y"
    { M ((yyval.measure), (yyvsp[(1) - (2)].number), INCH_TO_COORD ((yyvsp[(1) - (2)].number))); }
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 2218 "parse_y.y"
    { M ((yyval.measure), (yyvsp[(1) - (2)].number), MM_TO_COORD ((yyvsp[(1) - (2)].number)) / 1000000.0); }
    break;

  case 201:

/* Line 1455 of yacc.c  */
#line 2219 "parse_y.y"
    { M ((yyval.measure), (yyvsp[(1) - (2)].number), MM_TO_COORD ((yyvsp[(1) - (2)].number)) / 1000000.0); }
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 2220 "parse_y.y"
    { M ((yyval.measure), (yyvsp[(1) - (2)].number), MM_TO_COORD ((yyvsp[(1) - (2)].number)) / 1000.0); }
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 2221 "parse_y.y"
    { M ((yyval.measure), (yyvsp[(1) - (2)].number), MM_TO_COORD ((yyvsp[(1) - (2)].number))); }
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 2222 "parse_y.y"
    { M ((yyval.measure), (yyvsp[(1) - (2)].number), MM_TO_COORD ((yyvsp[(1) - (2)].number)) * 1000.0); }
    break;

  case 205:

/* Line 1455 of yacc.c  */
#line 2223 "parse_y.y"
    { M ((yyval.measure), (yyvsp[(1) - (2)].number), MM_TO_COORD ((yyvsp[(1) - (2)].number)) * 1000000.0); }
    break;



/* Line 1455 of yacc.c  */
#line 3376 "parse_y.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 2226 "parse_y.y"


/* ---------------------------------------------------------------------------
 * error routine called by parser library
 */
int yyerror(const char * s)
{
	Message(_("ERROR parsing file '%s'\n"
		"    line:        %i\n"
		"    description: '%s'\n"),
		yyfilename, yylineno, s);
	return(0);
}

int yywrap()
{
  return 1;
}

static int
check_file_version (int ver)
{
  if ( ver > PCB_FILE_VERSION ) {
    Message (_("ERROR:  The file you are attempting to load is in a format\n"
	     "which is too new for this version of pcb.  To load this file\n"
	     "you need a version of pcb which is >= %d.  If you are\n"
	     "using a version built from git source, the source date\n"
	     "must be >= %d.  This copy of pcb can only read files\n"
	     "up to file version %d.\n"), ver, ver, PCB_FILE_VERSION);
    return 1;
  }
  
  return 0;
}

static void
do_measure (PLMeasure *m, Coord i, double d, int u)
{
  m->ival = i;
  m->bval = round (d);
  m->dval = d;
  m->has_units = u;
}

static int
integer_value (PLMeasure m)
{
  if (m.has_units)
    yyerror("units ignored here");
  return m.ival;
}

static Coord
old_units (PLMeasure m)
{
  if (m.has_units)
    return m.bval;
  return round (MIL_TO_COORD (m.ival));
}

static Coord
new_units (PLMeasure m)
{
  if (m.has_units)
    return m.bval;
  return round (MIL_TO_COORD (m.ival) / 100.0);
}

